﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using Infragistics.Windows.Editors;
using System.ComponentModel;
using System.Data;
using Infragistics.Windows.Controls;

namespace xamDataGridWithCombo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        #region "Variables"

        DataTable DtAttributes = null;
        DataTable _dtDestModsAttr = null;

        #endregion

        #region "Constructor"

        public MainWindow()
        {
            try
            {

                InitializeComponent();

                DtAttributes = new DataTable();

                DtAttributes.Columns.Add("IsMandatory");
                DtAttributes.Columns["IsMandatory"].SetOrdinal(0);

                DtAttributes.Columns.Add("SourceModule");
                DtAttributes.Columns["SourceModule"].DefaultValue = "TestModule";
                DtAttributes.Columns["SourceModule"].SetOrdinal(1);

                DtAttributes.Columns.Add("SourceModAttrField");
                DtAttributes.Columns.Add("SourceModAttrLabel");
                DtAttributes.Columns.Add("ServiceDataType");
                DtAttributes.Columns.Add("MaxLength");
                DtAttributes.Columns.Add("DestinationModAttrField");
                DtAttributes.Columns.Add("DestinationModAttrLabel");
                DtAttributes.Columns.Add("DestinationDataType");

                DataRow drRow;

                drRow = DtAttributes.NewRow();
                drRow["SourceModAttrField"] = "Attr1";
                drRow["SourceModAttrLabel"] = "Attribute One";
                drRow["ServiceDataType"] = "CURRENCY";
                drRow["DestinationModAttrLabel"] = null;
                DtAttributes.Rows.Add(drRow);

                drRow = DtAttributes.NewRow();
                drRow["SourceModAttrField"] = "Attr2";
                drRow["SourceModAttrLabel"] = "Attribute Two";
                drRow["ServiceDataType"] = "CURRENCY";
                drRow["DestinationModAttrLabel"] = null;
                DtAttributes.Rows.Add(drRow);

                DtAttributes.DefaultView.Sort = "SourceModAttrLabel asc";
                DtAttributes = DtAttributes.DefaultView.ToTable();

                DtAttributes.Columns.Add("SortOrder", typeof(int));
                DtAttributes.Columns["SortOrder"].DefaultValue = 1;
                DtAttributes.Select().ToList<DataRow>().ForEach(r => r["SortOrder"] = 1);

                xdgAttributes.DataSource = DtAttributes.DefaultView;
                xdgAttributes.Records.FieldLayout.Settings.SelectionTypeCell = SelectionType.Single;


                foreach (Field objField in xdgAttributes.Records.FieldLayout.Fields)
                {
                    objField.Settings.LabelTextAlignment = TextAlignment.Left;
                    objField.Settings.CellClickAction = CellClickAction.EnterEditModeIfAllowed;
                    objField.Settings.AllowResize = false;
                    objField.Settings.AllowEdit = false;
                    objField.Settings.LabelClickAction = LabelClickAction.Nothing;

                    if (objField.Name != "SourceModAttrLabel" & objField.Name != "DestinationModAttrLabel")
                    {
                        objField.Visibility = System.Windows.Visibility.Collapsed;
                    }
                    else
                    {
                        objField.Visibility = System.Windows.Visibility.Visible;
                    }

                    if (objField.Name == "SourceModAttrLabel")
                    {
                        Style objSourceModAttrLabelStyle = this.TryFindResource("SourceModAttrLabelStyle") as Style;
                        objField.Settings.CellValuePresenterStyle = objSourceModAttrLabelStyle;
                        objField.Label = Convert.ToString("TestModule") + " Attributes";
                        objField.Width = FieldLength.Auto;
                        objField.IsScrollTipField = true;
                        objField.Settings.AutoSizeOptions = FieldAutoSizeOptions.All;
                        objField.PerformAutoSize(FieldAutoSizeOptions.DataCells, FieldAutoSizeScope.AllRecords);
                        objField.Settings.CellMinWidth = objField.CellMinWidthResolved + 10;
                        objField.Settings.AllowEdit = false;
                    }

                    if (objField.Name == "DestinationModAttrLabel")
                    {
                        objField.Label = " Combo Fields";
                        objField.Settings.AllowEdit = true;
                        objField.Settings.AutoSizeOptions = FieldAutoSizeOptions.All;
                    }
                    if (objField.Name == "IsMandatory")
                    {
                        objField.Label = "";
                        objField.Visibility = System.Windows.Visibility.Visible;
                    }
                }

                ComboBoxItemsProvider cbipModAttributeProvider = this.TryFindResource("cbipModAttribute") as ComboBoxItemsProvider;
                _dtDestModsAttr = new DataTable();
                _dtDestModsAttr.Columns.Add("Field");
                _dtDestModsAttr.Columns.Add("Label");
                _dtDestModsAttr.Columns.Add("DataType");
                _dtDestModsAttr.Columns.Add("InUse");
                _dtDestModsAttr.Columns.Add("SortOrder");

                DataRow drAttrRow;

                drAttrRow = _dtDestModsAttr.NewRow();
                drAttrRow["Field"] = "ComboVal1";
                drAttrRow["Label"] = "Combo Label One";
                drAttrRow["DataType"] = "CURRENCY";
                drAttrRow["InUse"] = 1;
                drAttrRow["SortOrder"] = 0;
                _dtDestModsAttr.Rows.Add(drAttrRow);

                drAttrRow = _dtDestModsAttr.NewRow();
                drAttrRow["Field"] = "ComboVal2";
                drAttrRow["Label"] = "Combo Label Two";
                drAttrRow["DataType"] = "CURRENCY";
                drAttrRow["InUse"] = 1;
                drAttrRow["SortOrder"] = 0;
                _dtDestModsAttr.Rows.Add(drAttrRow);


                xdgAttributes.Records.FieldLayout.Fields["DestinationModAttrLabel"].Settings.EditorStyle = (Style)this.TryFindResource("ComboStyle");
                xdgAttributes.Records.FieldLayout.Fields["DestinationModAttrLabel"].Settings.CellClickAction = CellClickAction.EnterEditModeIfAllowed;
                
                if (DtAttributes.Columns.IndexOf("DestinationModAttrField") != -1)
                {
                    DtAttributes.Select("DestinationModAttrField <> '' OR  DestinationModAttrField IS NOT NULL").ToList<DataRow>().ForEach(r => r["SortOrder"] = 0);
                }

                foreach (Field objField in xdgAttributes.Records.FieldLayout.Fields)
                {
                    if (objField.Visibility == System.Windows.Visibility.Visible && objField.Name != "IsMandatory")
                    {
                        objField.PerformAutoSize(FieldAutoSizeOptions.All, FieldAutoSizeScope.AllRecords);
                        objField.Width = new FieldLength(objField.CellWidthResolved + 10);
                    }
                }

                xdgAttributes.ExecuteCommand(DataPresenterCommands.CommitChangesToAllRecords);
            }
            catch (Exception ex)
            { }
        }

        #endregion

        #region "Methods"

        private void ApplyAttributeFilter(string filterVal, XamComboEditor combo)
        {
            try
            {
                if (IsValidDataTable(_dtDestModsAttr) && filterVal != "New Attribute")
                {
                    string dimensionRowFilter = getFilterString();
                    _dtDestModsAttr.DefaultView.RowFilter = null;
                    if (!string.IsNullOrEmpty(dimensionRowFilter.Trim()))
                    {
                        if (!string.IsNullOrEmpty(filterVal) && dimensionRowFilter.Contains("'" + filterVal + "'") == true)
                        {
                            dimensionRowFilter = dimensionRowFilter + ",";
                            dimensionRowFilter = dimensionRowFilter.Replace("'" + filterVal + "',", "");
                            if (dimensionRowFilter.EndsWith(","))
                            { dimensionRowFilter = dimensionRowFilter.Substring(0, dimensionRowFilter.Length - 1); }
                        }
                        if (!String.IsNullOrEmpty(dimensionRowFilter.Trim()))
                        {
                            ((DataView)combo.ItemsSource).RowFilter = " Label Not In(" + dimensionRowFilter + ")";
                        }
                    }
                }
            }
            catch (Exception ex)
            {                
                throw ex;
            }
        }

        private string getFilterString()
        {
            string rowFilter = "";
            try
            {

                if (DtAttributes.Select("DestinationModAttrField <> ''").Length > 0)
                {
                    rowFilter = String.Join("','", DtAttributes.Select("DestinationModAttrField <> ''").Select(r => r["DestinationModAttrLabel"].ToString()).ToArray());
                    rowFilter = "'" + rowFilter + "'";
                }
            }
            catch (Exception ex)
            {                
                throw ex;
            }
            return rowFilter;
        }
        
        public static Boolean IsValidDataSet(DataSet pDataSet)
        {
            try
            {
                if (pDataSet != null)
                {
                    if (pDataSet.Tables.Count != 0)
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
             
        public static bool IsValidDataTable(DataTable pDataTable)
        {
            try
            {
                if (pDataTable != null)
                {
                    if (pDataTable.Rows.Count != 0)
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        
        #endregion
        
        #region "Event Handlers"

        private void XamComboEditor_DropDownClosed(object sender, RoutedEventArgs e)
        {
            try
            {
                if (sender.GetType() == typeof(XamComboEditor))
                {
                    (sender as XamComboEditor).SelectedText = Convert.ToString((sender as XamComboEditor).DisplayValue);
                    (sender as XamComboEditor).Text = Convert.ToString((sender as XamComboEditor).DisplayValue);
                    ApplyAttributeFilter((sender as XamComboEditor).Text, (sender as XamComboEditor));
                }
            }
            catch (Exception ex)
            {

            }
        }

        private void XamComboEditor_DropDownOpened(object sender, RoutedEventArgs e)
        {
            try
            {
                if (sender.GetType() == typeof(XamComboEditor))
                {
                    if ((sender as XamComboEditor).ItemsSource == null)
                    {
                        DataTable dtTemp = new DataTable();
                        dtTemp = _dtDestModsAttr.Copy();
                        if (IsValidDataTable(_dtDestModsAttr))
                        {
                            //dtTemp.Columns.Add("SortOrder", typeof(int));
                            //dtTemp.Columns["SortOrder"].DefaultValue = 0;
                            //dtTemp.Select().ToList<DataRow>().ForEach(r => r["SortOrder"] = 0);

                            DataRow drNew = dtTemp.NewRow();
                            drNew["Field"] = "New Attribute";
                            drNew["Label"] = "New Attribute";
                            drNew["SortOrder"] = 100;
                            dtTemp.Rows.Add(drNew);

                            (sender as XamComboEditor).ItemsSource = dtTemp.DefaultView;
                            //(sender as XamComboEditor).DisplayMemberPath = "Label";
                            //(sender as XamComboEditor).ValuePath = "Field";

                            (sender as XamComboEditor).ValuePath = "Label";

                            //(sender as XamComboEditor).Style = (Style)this.TryFindResource("ComboStyle");

                            SortDescription sdSortOrder = new SortDescription();
                            sdSortOrder.Direction = ListSortDirection.Ascending;
                            sdSortOrder.PropertyName = "SortOrder";
                            (sender as XamComboEditor).ItemsProvider.Items.SortDescriptions.Add(sdSortOrder);

                            SortDescription sdModuleName = new SortDescription();
                            sdModuleName.Direction = ListSortDirection.Ascending;
                            sdModuleName.PropertyName = "Label";
                            (sender as XamComboEditor).ItemsProvider.Items.SortDescriptions.Add(sdModuleName);


                            //cbipDestDimsProvider.ItemsSource = _dtDestDims.DefaultView;
                            //cbipDestDimsProvider.DisplayMemberPath = "Label";
                            //cbipDestDimsProvider.ValuePath = "Field";

                        }
                    }
                }
                ApplyAttributeFilter((sender as XamComboEditor).Text, (sender as XamComboEditor));

                //if ((sender as XamComboEditor).DisplayValue != null)
                //{
                //    (sender as XamComboEditor).SelectedText = (sender as XamComboEditor).DisplayValue.ToString();
                //}
            }
            catch (Exception ex)
            {                
            }
        }

        private void xdgAttributes_CellActivating(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatingEventArgs e)
        {
            try
            {
                if (e.Cell.Field.Name != "DestinationModAttrLabel")
                {
                    e.Cancel = true;
                }
            }
            catch (Exception ex)
            {
            }

        }

        private void XamComboEditor_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            try
            {
                if ((sender as XamComboEditor).SelectedItem != null && (sender as XamComboEditor).Value.ToString() == "New Attribute")
                {
                    string serviceAttributeName = xdgAttributes.ActiveCell.Record.Cells["SourceModAttrField"].Value.ToString().Replace(".", "_");

                    //wndNewObject objNewObject = new wndNewObject(NewObjectType.ModuleAttribute, _mainWindow, xdgAttributes.ActiveCell.Record.Cells["SourceModAttrLabel"].Value.ToString(), SourceModule, xdgAttributes.ActiveCell.Record.Cells["ServiceDataType"].Value.ToString(), xdgAttributes.ActiveCell.Record.Cells["MaxLength"].Value.ToString());
                    //objNewObject.DestinationModule = DestinationModule;
                    //objNewObject.serviceAttributeName = serviceAttributeName;
                    //objNewObject.ShowDialog();
                    //if (objNewObject.WindowResult == true && objNewObject.IsColumnExists == false)
                    //{
                    //    DataRow drNew = _dtDestModsAttr.NewRow();
                    //    drNew["Field"] = "c_" + xdgAttributes.ActiveCell.Record.Cells["SourceModAttrField"].Value.ToString();
                    //    drNew["Label"] = objNewObject.Label;
                    //    drNew["InUse"] = true;
                    //    drNew["DataType"] = objNewObject.cmbDataType.Value.ToString();
                    //    drNew["SortOrder"] = objNewObject.SortOrder;
                    //    _dtDestModsAttr.Rows.Add(drNew);

                    //    DataRowView drNewView = ((DataView)(sender as XamComboEditor).ItemsSource).AddNew();
                    //    drNewView["Field"] = "c_" + xdgAttributes.ActiveCell.Record.Cells["SourceModAttrField"].Value.ToString();
                    //    drNewView["Label"] = objNewObject.Label;
                    //    drNewView["InUse"] = true;
                    //    drNewView["DataType"] = objNewObject.cmbDataType.Value.ToString();
                    //    drNewView["SortOrder"] = objNewObject.SortOrder;
                    //    drNewView.EndEdit();

                    //    (sender as XamComboEditor).Value = "c_" + xdgAttributes.ActiveCell.Record.Cells["SourceModAttrField"].Value.ToString();
                    //}
                    //else if (objNewObject.WindowResult == true && objNewObject.IsColumnExists == true)
                    //{
                    //    (sender as XamComboEditor).Text = null;
                    //    (sender as XamComboEditor).Value = null;
                    //    xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrField"].Value = null;
                    //    xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrLabel"].Value = null;
                    //    xdgAttributes.ActiveCell.Record.Cells["DestinationDataType"].Value = null;                        
                    //    //(sender as XamComboEditor).Value = "c_" + xdgAttributes.ActiveCell.Record.Cells["SourceDimAttrField"].Value.ToString();
                    //}
                    //else
                    //{
                    //    (sender as XamComboEditor).Text = null;
                    //    (sender as XamComboEditor).Value = null;
                    //    xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrField"].Value = null;
                    //    xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrLabel"].Value = null;
                    //    xdgAttributes.ActiveCell.Record.Cells["DestinationDataType"].Value = null;
                    //}
                }
                else if ((sender as XamComboEditor).HasValueChanged)
                {
                    xdgAttributes.ExecuteCommand(DataPresenterCommands.CommitChangesToAllRecords);
                    //if (_dtDestModsAttr.Select("Field = '" + (sender as XamComboEditor).Value + "'").Length > 0 && Convert.ToBoolean(_dtDestModsAttr.Select("Field = '" + (sender as XamComboEditor).Value + "'")[0]["InUse"]) == false)
                    //{
                    //    _dataInstance.EnableModuleAttribute(DestinationModule, Convert.ToString((sender as XamComboEditor).Value), Convert.ToString((sender as XamComboEditor).Text), xdgAttributes.ActiveCell.Record.Cells["DestinationDataType"].Value.ToString(), false, false);
                    //}
                    xdgAttributes.ExecuteCommand(DataPresenterCommands.CommitChangesToAllRecords);
                    DataRow[] drCollec = DtAttributes.Select("SourceModAttrField = '" + xdgAttributes.ActiveCell.Record.Cells["SourceModAttrField"].Value + "'");
                    if (drCollec.Length > 0)
                    {
                        if (string.IsNullOrEmpty(Convert.ToString((sender as XamComboEditor).Value)))
                        {
                            drCollec[0]["DestinationModAttrField"] = null;
                            drCollec[0]["DestinationModAttrLabel"] = null;
                            drCollec[0]["DestinationDataType"] = null;
                        }
                        else
                        {
                            drCollec[0]["DestinationModAttrLabel"] = Convert.ToString((sender as XamComboEditor).Text);
                            drCollec[0]["DestinationModAttrField"] = Convert.ToString((sender as XamComboEditor).Value);
                            drCollec[0]["DestinationDataType"] = _dtDestModsAttr.Select("Label = '" + (sender as XamComboEditor).Value + "'")[0]["DataType"];
                        }
                    }

                    //xdgAttributes.ActiveCell.Record.Cells["DestinationDimAttrField"].Value = Convert.ToString((sender as XamComboEditor).Value);

                    if (String.IsNullOrEmpty((sender as XamComboEditor).Text) || (sender as XamComboEditor).SelectedItem == null)
                    {
                        (sender as XamComboEditor).Text = null;
                        (sender as XamComboEditor).Value = null;
                        xdgAttributes.ActiveCell.Record.Cells["DestinationDataType"].Value = null;
                        xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrField"].Value = null;
                        xdgAttributes.ActiveCell.Record.Cells["DestinationDataType"].Value = null;
                    }
                    else
                    {                        
                        xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrLabel"].Value = Convert.ToString((sender as XamComboEditor).Text);
                        xdgAttributes.ActiveCell.Record.Cells["DestinationModAttrField"].Value = Convert.ToString((sender as XamComboEditor).Value);
                        xdgAttributes.ActiveCell.Record.Cells["DestinationDataType"].Value = _dtDestModsAttr.Select("Label = '" + (sender as XamComboEditor).Value + "'")[0]["DataType"];
                    }

                    DtAttributes.AcceptChanges();

                    //xdgDimensions.ExecuteCommand(DataPresenterCommands.CommitChangesToAllRecords);
                    //xdgDimensions.ExecuteCommand(DataPresenterCommands.CommitChangesToActiveRecord);
                    //xdgDimensions.ExecuteCommand(DataPresenterCommands.EndEditModeAndCommitRecord);
                    //xdgDimensions.ActiveCell.EndEditMode();
                }
                //_parentControl.ValidateModuleLabelControls();
            }
            catch (Exception ex)
            {
                (sender as XamComboEditor).Text = null;
                (sender as XamComboEditor).Value = null;                
            }
        }

        private void DataRecordPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {
                if ((sender as DataRecordPresenter).IsHeaderRecord && Utilities.GetDescendantFromName(sender as DependencyObject, "darkLine") != null)
                {
                    (Utilities.GetDescendantFromName(sender as DependencyObject, "darkLine") as Rectangle).Fill = Brushes.Transparent;
                }
                else if ((sender as DataRecordPresenter).IsHeaderRecord && Utilities.GetDescendantFromName(sender as DependencyObject, "SpacerFill") != null && (Utilities.GetDescendantFromName(sender as DependencyObject, "SpacerFill") as CardPanel).Children.Count == 1)
                {
                    ((Utilities.GetDescendantFromName(sender as DependencyObject, "SpacerFill") as CardPanel).Children[0] as Border).BorderBrush = Brushes.Transparent;
                }
            }
            catch (Exception ex)
            {
                
            }
        }

        #endregion
    }

    #region "TemplateSelector Class"

    public class TemplateSelector : DataTemplateSelector
    {
        public DataTemplate DefaultnDataTemplate { get; set; }
        public DataTemplate HyperLinkDataTemplate { get; set; }

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            XamComboEditor editor = Utilities.GetAncestorFromType(container, typeof(XamComboEditor), true) as XamComboEditor;
            DataView dv = editor.ItemsProvider.ItemsSource as DataView;
            if ((item as DataRowView).Row.ItemArray[1] == dv.Table.Rows[dv.Table.Rows.Count - 1].ItemArray[1])
            {
                //return App.Current.TryFindResource("hyperlinkTemplate") as DataTemplate;
                return HyperLinkDataTemplate;
            }
            //return App.Current.TryFindResource("regularTemplate") as DataTemplate;
            return DefaultnDataTemplate;
        }
    }

    #endregion

    #region "ComboConverter Class"

    public class ComboConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                return value;
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }

    #endregion
}
